<?php
// --------------------------------------------------------------------------------
// 运费模块
// --------------------------------------------------------------------------------

class shipping 
{

	/**
	 * 构造函数
	 */
	public function __construct() 
	{
	}

	/**
	 * 取当前用户购物车的运费
	 */
	public function carFee($userid = 0, $shipping_id = 0) 
	{
		if(empty($userid)) $userid = param::get_cookie('_userid');
		if(empty($userid)) return 0;

		$buycar_db = pc_base::load_model('ishop_car_model');
		$products = $buycar_db->select(array('userid'=>$userid, 'status'=>'0'));

		$shipping_fee = 0; //运费	

		$shipping_need = false; //是否需要物流
		$shipping_total= 0; //总价格
		$shipping_quantity = 0; //总数量
		$pids = array(); //商品ID
		if(!empty($products))
		{
			foreach($products as $k=>$v)
			{
				if($v['isvirtual'] == 0){$shipping_need = true;}
				$shipping_total += $v['price'] * $v['quantity'];
				$pids[] = $v['pid'];
			}
		}

		if($shipping_need)
		{
			//取出用户地址（省）
			$address_db = pc_base::load_model('member_address_model');
			$address_info = $address_db->get_one(array('userid'=>$userid), 'province_id');
			if(empty($address_info))
			{
				return 0;
			}
			
			//取出物流
			$shipping_db = pc_base::load_model('ishop_shipping_model');
			$shipping_info = $shipping_db->get_one(array('shipping_id'=>$shipping_id, 'enabled'=>1));
			
			if(empty($shipping_info))
			{
				return 0;
			}
			$shipping_info['shipping_config'] = string2array($shipping_info['shipping_config']);

			if(isset($shipping_info['shipping_config'][$address_info['province_id']]))
				$arr = $shipping_info['shipping_config'][$address_info['province_id']];
			else
				$arr = $shipping_info;

			//自取
			if($arr['shipping_mode'] == 'self')
			{
				$shipping_fee = 0;
			}
			elseif($arr['shipping_mode'] == 'fixed')
			{
				$shipping_fee = $arr['shipping_base_fee'];
				if($arr['shipping_money_fee'] > 0 && $arr['shipping_money_fee'] >= $shipping_total)
				{
					$shipping_fee = 0;
				}
			}
			elseif($arr['shipping_mode'] == 'weight')
			{
				$shipping_fee = $arr['shipping_base_fee'];
				if($arr['shipping_money_fee'] > 0 && $arr['shipping_money_fee'] >= $shipping_total)
				{
					$shipping_fee = 0;
				}
				else
				{
					//取重量
					$product_db  = pc_base::load_model('ishop_product_model');
					$weight_list = array_to($product_db->select(" pid IN (".implode(',', $pids).") ", 'pid,spe'), 'pid', 'spe');
					$weights = 0;
					foreach($products as $k=>$v)
					{
						$weights += $weight_list[$v['pid']] * $v['quantity'];
					}
					if( ($weights > $arr['shipping_weight_first']) && $arr['shipping_weight_step'] > 0 )
					{
						$shipping_fee += intval( ($weights - $arr['shipping_weight_first']) / $arr['shipping_weight_step'] ) * $arr['shipping_weight_step_fee'] ;
						$shipping_fee += ($weights - $arr['shipping_weight_first']) % $arr['shipping_weight_step'] > 0 ?  $arr['shipping_weight_step_fee'] : 0 ;
					}
				}
			}
			elseif($arr['shipping_mode'] == 'number')
			{
				$shipping_fee = $arr['shipping_base_fee'];
				if($arr['shipping_money_fee'] > 0 && $arr['shipping_money_fee'] >= $shipping_total)
				{
					$shipping_fee = 0;
				}
				else
				{
					if( $shipping_quantity > 1 )
					{
						$shipping_fee += ($shipping_quantity - 1)  * $arr['shipping_number_one_fee'] ;
					}
				}
			}				
		}

		return $shipping_fee;
	}
}