<?php

/**
 * 城际快递插件
 */

/* 模块的基本信息 */
if (isset($set_modules) && $set_modules == TRUE)
{
    $i = (isset($modules)) ? count($modules) : 0;

    /* 配送方式插件的代码必须和文件名保持一致 */
    $modules[$i]['code']    = 'city_express';

    /* 配送方式的描述 */
    $modules[$i]['desc']    = 'city_express_desc';

    /* 配送接口需要的参数 */
    $modules[$i]['configure'] = array(
                                   array('name' => 'shipping_mode',				'value' => 'number'),	//计费方式 'self','fixed','weight','number'	
                                   array('name' => 'shipping_base_fee',			'value' => '10'),			//基本费用
                                   array('name' => 'shipping_weight_first',     'value' => '1'),			//首重(kg)
                                   array('name' => 'shipping_weight_step',		'value' => '0.5'),			//每添加多少重量(kg)
                                   array('name' => 'shipping_weight_step_fee',  'value' => '5'),			//每添加重量的费用
                                   array('name' => 'shipping_number_one_fee',   'value' => '5'),			//每添加一件的费用
                                   array('name' => 'shipping_money_fee',		'value' => '0'),			//免费额度
                                );

    return;
}

class city_express
{
    /*------------------------------------------------------ */
    //-- PUBLIC ATTRIBUTEs
    /*------------------------------------------------------ */

    /**
     * 配置信息
     */
    var $configure;

    /*------------------------------------------------------ */
    //-- PUBLIC METHODs
    /*------------------------------------------------------ */

    /**
     * 构造函数
     *
     * @param: $configure[array]    配送方式的参数的数组
     *
     * @return null
     */
    function city_express($cfg=array())
    {
        foreach ($cfg AS $key=>$val)
        {
            $this->configure[$val['name']] = $val['value'];
        }
    }

    /**
     * 计算订单的配送费用的函数
     *
     * @param   float   $goods_weight   商品重量
     * @param   float   $goods_amount   商品金额
     * @return  decimal
     */
    function calculate($goods_weight, $goods_amount)
    {
        if ($this->configure['free_money'] > 0 && $goods_amount >= $this->configure['free_money'])
        {
            return 0;
        }
        else
        {
            return $this->configure['base_fee'];
        }
    }

    /**
     * 查询发货状态
     * 该配送方式不支持查询发货状态
     *
     * @access  public
     * @param   string  $invoice_sn     发货单号
     * @return  string
     */
    function query($invoice_sn)
    {
        return $invoice_sn;
    }
}

?>
