
DROP TABLE IF EXISTS `phpcms_ishop_shipping`;
CREATE TABLE `phpcms_ishop_shipping` (
  `shipping_id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `shipping_code` varchar(20) NOT NULL DEFAULT '' COMMENT '编码',
  `shipping_name` varchar(120) NOT NULL DEFAULT '' COMMENT '名称',
  `shipping_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `shipping_order` tinyint(6) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `shipping_mode` enum('self','fixed','weight','number') DEFAULT 'self' COMMENT '计费方式',
  `shipping_base_fee` decimal(5,2) DEFAULT '0.00' COMMENT '基本费用',
  `shipping_weight_first` float(5,2) NOT NULL DEFAULT '0.00' COMMENT '首重(kg)',
  `shipping_weight_step` float(5,2) DEFAULT '0.00' COMMENT '每添加多少重量(kg)',
  `shipping_weight_step_fee` decimal(5,2) DEFAULT '0.00' COMMENT '每添加重量的费用',
  `shipping_number_one_fee` decimal(5,2) DEFAULT '0.00' COMMENT '每添加一件的费用',
  `shipping_money_fee` decimal(10,2) DEFAULT '0.00' COMMENT '免费额度',
  `shipping_config` text COMMENT '配置具体区域',
  `enabled` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否可用',
  PRIMARY KEY (`shipping_id`),
  KEY `shipping_code` (`shipping_code`,`enabled`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of phpcms_ishop_shipping
-- ----------------------------
INSERT INTO `phpcms_ishop_shipping` VALUES ('1', '', '上门取货', '买家自己到商家指定地点取货', '0', 'self', '0.00', '0.00', '0.00', '0.00', '0.00', '0.00', '', '1');
INSERT INTO `phpcms_ishop_shipping` VALUES ('2', '', '中通速递', '中通快递的相关说明。', '0', 'number', '15.00', '1.00', '0.50', '5.00', '10.00', '0.00', 'array (\n  2 => \n  array (\n    \'province_name\' => \'北京市\',\n    \'shipping_mode\' => \'number\',\n    \'shipping_base_fee\' => \'20\',\n    \'shipping_number_one_fee\' => \'11\',\n    \'shipping_money_fee\' => \'0\',\n  ),\n)', '1');
INSERT INTO `phpcms_ishop_shipping` VALUES ('3', '', '顺丰速运', '江、浙、沪地区首重15元/KG，续重2元/KG，其余城市首重20元/KG', '0', 'weight', '15.00', '1.00', '1.00', '2.00', '15.00', '0.00', 'array (\n  2 => \n  array (\n    \'province_name\' => \'北京市\',\n    \'shipping_mode\' => \'number\',\n    \'shipping_base_fee\' => \'21.00\',\n    \'shipping_number_one_fee\' => \'2\',\n    \'shipping_money_fee\' => \'0.00\',\n  ),\n)', '1');
