<?php
defined('IN_PHPCMS') or exit('No permission resources.');

pc_base::load_app_class('admin', 'admin', 0);
pc_base::load_sys_class('form', 0, 0);
pc_base::load_app_func('global');
 
class shipping extends admin
{
	private $db;
	private $area;
	public function __construct()
	{
		$this->db   = pc_base::load_model('ishop_shipping_model');
		parent::__construct();		
	}
	public function shipping()
	{
	}

	/**
	 * 获得所有模块的名称以及链接地址
	 *
	 * @access      public
	 * @param       string      $directory      插件存放的目录
	 * @return      array
	 */
	private function read_modules($directory = '.')
	{
		$dir         = @opendir($directory);
		$set_modules = true;
		$modules     = array();

		while (false !== ($file = @readdir($dir)))
		{
			if (preg_match("/^.*?\.php$/", $file))
			{
				include_once($directory. '/' .$file);
			}
		}
		@closedir($dir);
		unset($set_modules);

		foreach ($modules AS $key => $value)
		{
			ksort($modules[$key]);
		}
		ksort($modules);

		return $modules;
	}

	/*------------------------------------------------------ */
	//-- 配送方式列表
	/*------------------------------------------------------ */
	public function manage()
	{    
		$where = '1 ';
		$size = 20;
		$count = $this->db->get_one($where, 'count(*) as num ', '');
		$total = $count['num'];
		$page = max($_GET['page'], 1);
		$lists = $this->db->select($where, '*', ($page-1)*$size . ',' . $size, 'shipping_order asc, shipping_id asc'); 
		$pages = pages($total, $page, $size);
		
		$big_menu = array('javascript:window.top.art.dialog({id:\'add\',iframe:\'?m=ishop&c=shipping&a=add\', title:\''.L('shipping_add').'\', width:\'900\', height:\'500\', lock:true}, function(){var d = window.top.art.dialog({id:\'add\'}).data.iframe;var form = d.document.getElementById(\'dosubmit\');form.click();return false;}, function(){window.top.art.dialog({id:\'add\'}).close()});void(0);', L('shipping_add'));
		include $this->admin_tpl('shipping_list');
	}  
	
	public function add()
	{
		if(isset($_POST['dosubmit']))
		{
			$shipping_name				= trim($_POST['shipping_name']);
			$shipping_desc				= trim($_POST['shipping_desc']);
			$shipping_mode				= trim($_POST['shipping_mode']);
			$shipping_base_fee			= trim($_POST['shipping_base_fee']);
			$shipping_weight_first		= trim($_POST['shipping_weight_first']);
			$shipping_weight_step		= trim($_POST['shipping_weight_step']);
			$shipping_weight_step_fee   = trim($_POST['shipping_weight_step_fee']);
			$shipping_number_one_fee	= trim($_POST['shipping_number_one_fee']);
			$shipping_money_fee			= trim($_POST['shipping_money_fee']);


			$tmp			= $_POST['shipping_config'];
			$shipping_config= array();
			if(!empty($tmp))
			{
				foreach($tmp as $k=>$v)
				{
					if($v['shipping_mode'] == 'self')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
						);
					}
					elseif($v['shipping_mode'] == 'fixed')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
						);
					}
					elseif($v['shipping_mode'] == 'weight')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
							'shipping_weight_first' => trim($v['shipping_weight_first']),
							'shipping_weight_step' => trim($v['shipping_weight_step']),
							'shipping_weight_step_fee' => trim($v['shipping_weight_step_fee']),
							'shipping_money_fee' => trim($v['shipping_money_fee']),
						);
					}
					elseif($v['shipping_mode'] == 'number')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
							'shipping_number_one_fee' => trim($v['shipping_number_one_fee']),
							'shipping_money_fee' => trim($v['shipping_money_fee']),
						);
					}
				}
			}

			$data = array(
				'shipping_name'				=> $shipping_name,
				'shipping_desc'				=> $shipping_desc,
				'shipping_mode'				=> $shipping_mode,
				'shipping_base_fee'			=> $shipping_base_fee,
				'shipping_weight_first'		=> $shipping_weight_first,
				'shipping_weight_step'		=> $shipping_weight_step,
				'shipping_weight_step_fee'	=> $shipping_weight_step_fee,
				'shipping_number_one_fee'	=> $shipping_number_one_fee,
				'shipping_money_fee'		=> $shipping_money_fee,
				'shipping_config'			=> !empty($shipping_config) ? array2string($shipping_config) : '',
			);

			$this->db->insert($data, true);    

			showmessage(L('operation_success'), 'blank', '', 'add');
		}
		else
		{
			//取出省份
			$linkage_db = pc_base::load_model('linkage_model');
			$province_list = array_to($linkage_db->select("parentid=0 and keyid=1", 'linkageid, name'), 'linkageid', 'name');

			$show_header = true;
			include $this->admin_tpl('shipping_op');
		}  
	}
	
	public function edit()
	{
		if(isset($_POST['dosubmit']))
		{
			$id = intval($_POST['id']);
			if(empty($id) || !$info = $this->db->get_one(array('shipping_id'=>$id)))
			{
				showmessage(L('parameters_error'));  
			}

			$shipping_name				= trim($_POST['shipping_name']);
			$shipping_desc				= trim($_POST['shipping_desc']);
			$shipping_mode				= trim($_POST['shipping_mode']);
			$shipping_base_fee			= trim($_POST['shipping_base_fee']);
			$shipping_weight_first		= trim($_POST['shipping_weight_first']);
			$shipping_weight_step		= trim($_POST['shipping_weight_step']);
			$shipping_weight_step_fee   = trim($_POST['shipping_weight_step_fee']);
			$shipping_number_one_fee	= trim($_POST['shipping_number_one_fee']);
			$shipping_money_fee			= trim($_POST['shipping_money_fee']);


			$tmp			= $_POST['shipping_config'];
			$shipping_config= array();
			if(!empty($tmp))
			{
				foreach($tmp as $k=>$v)
				{
					if($v['shipping_mode'] == 'self')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
						);
					}
					elseif($v['shipping_mode'] == 'fixed')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
						);
					}
					elseif($v['shipping_mode'] == 'weight')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
							'shipping_weight_first' => trim($v['shipping_weight_first']),
							'shipping_weight_step' => trim($v['shipping_weight_step']),
							'shipping_weight_step_fee' => trim($v['shipping_weight_step_fee']),
							'shipping_money_fee' => trim($v['shipping_money_fee']),
						);
					}
					elseif($v['shipping_mode'] == 'number')
					{
						$shipping_config[$k] = array(
							'province_name' => trim($v['province_name']),
							'shipping_mode' => trim($v['shipping_mode']),
							'shipping_base_fee' => trim($v['shipping_base_fee']),
							'shipping_number_one_fee' => trim($v['shipping_number_one_fee']),
							'shipping_money_fee' => trim($v['shipping_money_fee']),
						);
					}
				}
			}

			$data = array(
				'shipping_name'				=> $shipping_name,
				'shipping_desc'				=> $shipping_desc,
				'shipping_mode'				=> $shipping_mode,
				'shipping_base_fee'			=> $shipping_base_fee,
				'shipping_weight_first'		=> $shipping_weight_first,
				'shipping_weight_step'		=> $shipping_weight_step,
				'shipping_weight_step_fee'	=> $shipping_weight_step_fee,
				'shipping_number_one_fee'	=> $shipping_number_one_fee,
				'shipping_money_fee'		=> $shipping_money_fee,
				'shipping_config'			=> !empty($shipping_config) ? array2string($shipping_config) : '',
			);

			$this->db->update($data, array('shipping_id'=>$id));    

			showmessage(L('operation_success'), 'blank', '', 'edit');
		}
		else
		{
			$id = intval($_GET['id']);
			if(empty($id) || !$info = $this->db->get_one(array('shipping_id'=>$id)))
			{
				showmessage(L('parameters_error'));  
			}

			$info['shipping_config'] = string2array($info['shipping_config']);

			//取出省份
			$linkage_db = pc_base::load_model('linkage_model');
			$province_list = array_to($linkage_db->select("parentid=0 and keyid=1", 'linkageid, name'), 'linkageid', 'name');

			$show_header = true;
			include $this->admin_tpl('shipping_op');
		}  
	}
	
	public function del()
	{   
		$id = intval($_GET['id']);
		if(empty($id) || !$info = $this->db->get_one(array('shipping_id'=>$id)))
		{
			showmessage(L('parameters_error'),HTTP_REFERER);  
		}

		$this->db->delete(array('shipping_id'=>$id));
		showmessage(L('operation_success'),HTTP_REFERER); 
	}

	//切换
	public function change_enabled()
	{
		$id = intval($_GET['id']);
		if(empty($id) || !$info = $this->db->get_one(array('shipping_id'=>$id)))
		{
			showmessage(L('parameters_error'), HTTP_REFERER);  
		}

		$this->db->update(array('enabled'=>$info['enabled'] > 0 ? 0 : 1), array('shipping_id'=>$id));
		showmessage(L('operation_success'),HTTP_REFERER); 
	}
}
?>
